unit ImageSizeDialog;

interface

uses NLib, NForm, NkvImage;

type
  TImageSizeDlg = class(TDialog)
    Image: TNkVImage;
    Width: Integer;
    Height: Integer;
    Update: Boolean;
    procedure Init(var DefaultFocus: TWindow); override;
    procedure Ok; override;
    procedure Change(Id: Integer); override;
  end;

implementation

{$I dialogid.inc}

procedure TImageSizeDlg.Init(var DefaultFocus: TWindow);
begin
  Items[IDC_WIDTH].SetText(IStr(Width));
  Items[IDC_HEIGHT].SetText(IStr(Height));
  Select(IDC_WIDTH);
  DefaultFocus := Items[IDC_WIDTH];
end;

procedure TImageSizeDlg.Ok;
begin
  Width := SInt(Items[IDC_WIDTH].Text);
  Height := SInt(Items[IDC_HEIGHT].Text);
  Update := True;
end;

procedure TImageSizeDlg.Change(Id: Integer);
var
 w, h: Integer;
begin
  w := SInt(Items[IDC_WIDTH].Text);
  h := SInt(Items[IDC_HEIGHT].Text);
  case Id of
    IDC_WIDTH:
      if Items[IDC_WIDTH].Focused then
        Items[IDC_HEIGHT].SetText(IStr(RoundOff(w*Image.Height/Image.Width)));
    IDC_HEIGHT:
      if Items[IDC_HEIGHT].Focused then
        Items[IDC_WIDTH].SetText(IStr(RoundOff(h*Image.Width/Image.Height)));
  end;
end;

end.

